/* Generated By:JavaCC: Do not edit this line. ESFParser.java */
package org.lwes.db;

import java.math.BigInteger;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import org.lwes.FieldType;
import org.lwes.util.IPAddress;

@SuppressWarnings("all") public class ESFParser implements ESFParserConstants {

    private static transient Log log = LogFactory.getLog(ESFParser.class);

  private String currentEvent;
  private EventTemplateDB eventTemplateDB;

  public void setEventTemplateDB(EventTemplateDB DB)
    { eventTemplateDB = DB; }

  public EventTemplateDB getEventTemplateDB()
    { return eventTemplateDB; }

  public void setCurrentEvent(String evt)
    { currentEvent = evt; }

  public String getCurrentEvent()
    { return currentEvent; }

  public String removeQuotes(String str) {
    return str.replace("\u005c"","");
  }

/**
 * A list of events
 */
  final public void eventlist() throws ParseException {
    event();
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ID:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      event();
    }
    jj_consume_token(0);
  }

/**
 * a single event
 */
  final public void event() throws ParseException {
    eventName();
    jj_consume_token(22);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REQ:
    case OPT:
    case ID:
      attributeList();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    jj_consume_token(23);
  }

/**
 * The name of an event, should be max 256 chars ([a-zA-Z0-9_]*)
 */
  final public void eventName() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    if ( getEventTemplateDB().addEvent(t.image))
    {
      setCurrentEvent(t.image);
    }
    else
    {
      {if (true) throw new ParseException("Problem adding event "+t.image);}
    }
  }

  final public void attributeList() throws ParseException {
    attribute();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REQ:
      case OPT:
      case ID:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_2;
      }
      attribute();
    }
  }

  final public String stringLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(STRING_LITERAL);
       {if (true) return removeQuotes(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public boolean booleanLiteral() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
    {if (true) return true;}
      break;
    case FALSE:
      jj_consume_token(FALSE);
    {if (true) return false;}
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public int integerLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(INTEGER_LITERAL);
    try {
      {if (true) return Integer.parseInt(t.image);}
    } catch (NumberFormatException e) {
      {if (true) throw new Error();}
    }
    throw new Error("Missing return statement in function");
  }

  final public BigInteger bigIntegerLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(BIG_INTEGER_LITERAL);
    {if (true) return new BigInteger(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public IPAddress ipaddrLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(IPADDR_LITERAL);
    {if (true) return new IPAddress(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public double doubleLiteral() throws ParseException {
    Token t;
    t = jj_consume_token(DOUBLE_LITERAL);
       try {
         {if (true) return Double.parseDouble(t.image);}
       } catch (NumberFormatException e) {
         {if (true) throw new Error();}
       }
    throw new Error("Missing return statement in function");
  }

  final public Object defaultValue() throws ParseException {
    Object obj;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      obj = integerLiteral();
      {if (true) return obj;}
      break;
    case BIG_INTEGER_LITERAL:
      obj = bigIntegerLiteral();
      {if (true) return obj;}
      break;
    case DOUBLE_LITERAL:
      obj = doubleLiteral();
      {if (true) return obj;}
      break;
    case TRUE:
    case FALSE:
      obj = booleanLiteral();
      {if (true) return obj;}
      break;
    case STRING_LITERAL:
      obj = stringLiteral();
      {if (true) return obj;}
      break;
    case IPADDR_LITERAL:
      obj = ipaddrLiteral();
      {if (true) return obj;}
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public boolean required() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REQ:
      jj_consume_token(REQ);
      {if (true) return true;}
      break;
    case OPT:
      jj_consume_token(OPT);
      {if (true) return false;}
      break;
    default:
      jj_la1[5] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public void attribute() throws ParseException {
  FieldType aType;
  String anAttribute;
  int anArraySize = 0;
  boolean required = false;
  Object aDefaultValue = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case REQ:
    case OPT:
      required = required();
      aType = type();
      anAttribute = attributeName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        jj_consume_token(LBRACKET);
        anArraySize = integerLiteral();
        jj_consume_token(RBRACKET);
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 24:
        jj_consume_token(24);
        aDefaultValue = defaultValue();
        break;
      default:
        jj_la1[7] = jj_gen;
        ;
      }
      jj_consume_token(25);
      break;
    case ID:
      aType = type();
      anAttribute = attributeName();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACKET:
        jj_consume_token(LBRACKET);
        anArraySize = integerLiteral();
        jj_consume_token(RBRACKET);
        break;
      default:
        jj_la1[8] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 24:
        jj_consume_token(24);
        aDefaultValue = defaultValue();
        break;
      default:
        jj_la1[9] = jj_gen;
        ;
      }
      jj_consume_token(25);
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
      String evt = getCurrentEvent();
      if ( evt == null ) {if (true) throw new ParseException("Bad Event");}

      if (log.isTraceEnabled()) {
        log.trace("Type: "+aType+" attr: "+anAttribute+" size: "+anArraySize);
        log.trace("Required: "+required);
        log.trace("default value: "+aDefaultValue);
      }

      if (anArraySize > 0) {
        aType = aType.getArrayType();
      }

      if ( !getEventTemplateDB().addEventAttribute(evt,
                                                   anAttribute,
                                                   aType,
                                                   anArraySize,
                                                   required,
                                                   aDefaultValue))
      {
        {if (true) throw new ParseException("Problem adding attribute "+evt+"("
                                 +aType+","+anAttribute+")");}
      }
  }

  final public FieldType type() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    {if (true) return FieldType.byName(t.image);}
    throw new Error("Missing return statement in function");
  }

  final public String attributeName() throws ParseException {
  Token t;
    t = jj_consume_token(ID);
    {if (true) return t.image;}
    throw new Error("Missing return statement in function");
  }

  /** Generated Token Manager. */
  public ESFParserTokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[11];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x200000,0x200c00,0x200c00,0x3000,0x1f3000,0xc00,0x4000,0x1000000,0x4000,0x1000000,0x200c00,};
   }

  /** Constructor with InputStream. */
  public ESFParser(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public ESFParser(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new ESFParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public ESFParser(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new ESFParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public ESFParser(ESFParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(ESFParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 11; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List<int[]> jj_expentries = new java.util.ArrayList<int[]>();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[26];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 11; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 26; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
